<?php
namespace Drupal\smsgateway_msg91;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\eca\EcaServiceProvider;



/**
 * ECA Manager service.
 */
class EcaManager {

  /**
   * The config factory.
   *
   * @var \Drupal\Core\Config\ConfigFactoryInterface
   */
  protected $configFactory;
  protected $EcaEvent;

  /**
   * Constructs a new EcaManager object.
   *
   * @param \Drupal\Core\Config\ConfigFactoryInterface $config_factory
   *   The config factory.
   */
  public function __construct(ConfigFactoryInterface $config_factory) {
    $this->configFactory = $config_factory;
   
  }

  /**
   * Gets the action configuration from a given value.
   *
   * @param string $value
   *   The value to fetch the action configuration.
   *
   * @return array
   *   The action configuration array.
   */
  public function getActionConfigFromValue($value) {
     
    // Implement the logic to fetch and return the action configuration.
    // For example, you could load a config object based on the value.
    $config = $this->configFactory->get('smsgateway_msg91.actions.' . $value);
    return $config ? $config->getRawData() : [];
  }
  
    /**
   * Sets a value in the action configuration.
   *
   * @param string $value
   *   The identifier for the configuration object.
   * @param string $template
   *   The new template value.
   */
//  public function setActionConfigTemplate($value) {
//   //   dump($value);die;
//    $config = $this->configFactory->getEditable('smsgateway_msg91.actions.' . 'templateIdkey');
//    $config->set('templateId', $value);
//    $config->save();
//  }
  
  
    public function setActionConfigTemplate($value, $template) {
       // dump($value);die;
    $config = $this->configFactory->getEditable('smsgateway_msg91.actions.' . $value);
    $existing_templates = $config->get('template') ?: [];

    // Check if the new template is already in the list.
    if (!in_array($template, $existing_templates)) {
      // Append the new template to the existing templates.
      $existing_templates[] = $template;
      $config->set('template', $existing_templates);
      $config->save();
    }
  }
  
  public function getecaDetail(){
      
      return $configuration =  $this->EcaEvent->getConfiguration();
  }


  /**
   * Gets the template value from the action configuration.
   *
   * @param string $value
   *   The identifier for the configuration object.
   *
   * @return string
   *   The template value.
   */
//  public function getActionConfigTemplate($value) {
//    $config = $this->configFactory->get('smsgateway_msg91.actions.' . $value);
//    return $config ? $config->get('templateId') : '';
//  }
  
    public function getActionConfigTemplate($value) {
    $config = $this->configFactory->listAll('smsgateway_msg91.actions.' . $value);
    return $config ? $config->get('template') : [];
  }

}
