<?php

declare(strict_types=1);

namespace Drupal\smsgateway_msg91;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;

/**
 * Provides a list controller for the email templates entity type.
 */
final class EmailTemplatesListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader(): array {
    
    $header['id'] = $this->t('ID');
    $header['templateName'] = $this->t('templateName');
    $header['templateId'] = $this->t('templateId');
    $header['status'] = $this->t('Status');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity): array {
    /** @var \Drupal\smsgateway_msg91\EmailTemplatesInterface $entity */
    $row['id'] = $entity->toLink();
    $row['templateName'] = $entity->get('templateName')->value;
    $row['templateId'] = $entity->get('templateId')->value;
    $row['status'] = $entity->get('status')->value ? $this->t('Enabled') : $this->t('Disabled');
    return $row + parent::buildRow($entity);
  }

}
