<?php

namespace Drupal\smsgateway_msg91\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

class EmailTemplateSelectionForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'email_template_selection_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    // Fetch available email templates. Adjust this to your actual method of fetching templates.
    $email_templates = [
      'template_1' => $this->t('Template 1'),
      'template_2' => $this->t('Template 2'),
      // Add more templates as needed.
    ];

    $form['email_template'] = [
      '#type' => 'select',
      '#title' => $this->t('Select Email Template'),
      '#options' => $email_templates,
    ];

    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Save'),
      '#ajax' => [
        'callback' => '::submitFormAjax',
        'event' => 'click',
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    // Handle form submission and save the selected email template.
    $selected_template = $form_state->getValue('email_template');
    // Save the selected template to your configuration or state as needed.
  }

  /**
   * Ajax callback for form submission.
   */
  public function submitFormAjax(array &$form, FormStateInterface $form_state) {
    $response = new \Drupal\Core\Ajax\AjaxResponse();
    $response->addCommand(new \Drupal\Core\Ajax\CloseModalDialogCommand());
    return $response;
  }
}
