<?php 
namespace Drupal\smsgateway_msg91\Plugin\Action;


use Drupal\Core\Access\AccessResult;
use Drupal\Core\Action\ActionBase;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\eca\Plugin\Action\ConfigurableActionBase;
//use Drupal\easy_email\Service\EmailHandlerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\eca\Plugin\DataType\DataTransferObject;
use Drupal\node\Entity\Node;
use Drupal\paragraphs\Entity\Paragraph;
use Drupal\node\Entity\NodeType;


/**
 * Provides an Send Msg91 SMS Action.
 *
 * @Action(
 *   id = "ttn_send_msg91_sms",
 *   label = @Translation("Send Msg91 SMS"),
 *   type = "node",
 *   category = @Translation("Custom")
 * )
 */
//class SendMsg91SMS extends ActionBase implements ContainerFactoryPluginInterface {
class SendMsg91SMS extends ConfigurableActionBase {

 /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return ['token_name' => 'template'] + parent::defaultConfiguration();
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state): array {
    $form = parent::buildConfigurationForm($form, $form_state);
    
    $form['token_name'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Name of token'),
      '#description' => $this->t('The loaded current user will be stored into this token.'),
      '#default_value' => $this->configuration['token_name'],
      '#eca_token_reference' => TRUE,
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state): void {
    $this->configuration['token_name'] = $form_state->getValue('token_name');
    parent::submitConfigurationForm($form, $form_state);
  }

  

  /**
   * {@inheritdoc}
   */
    public function execute($entity = NULL) {
        $token_name= $this->configuration['token_name'];

        $token_services = \Drupal::service('eca.token_services');  
        $token_data = $token_services->getTokenData($token_name);     
        $message_variable = $token_services->getTokenData('mobile_number'); 
        $template_var = $token_services->getTokenData('template_var');
        $templateArr = DataTransferObject::buildArrayFromUserInput($template_var);
        $dataArray = DataTransferObject::buildArrayFromUserInput($token_data);

        $templateId='';
        foreach ($dataArray as $key => $value) {
           $templateId= $value;
        }

        $mobile='';  
        $templateData = $this->getSMSTemplateData($templateId);
        $template_id = $templateData['templateId'];
        $message = $templateData['message'];   
        $status = \Drupal::service('smsgateway_msg91.default')->msg91_send_message($mobile, $message, $template_id,$templateArr);

    }
  
  
    public function getSMSTemplateData($templateId){
        $database = \Drupal::database();
        $query = $database->query("SELECT id,templateName,templateId,description__value as message,description__format FROM {smsgateway_msg91_email_templates}  WHERE status=1 AND id=" . $templateId);
        return $result = $query->fetchAssoc();
    }

    protected function loadParagraphs(array $paragraph_ids) {
      return Paragraph::loadMultiple($paragraph_ids);
    }

}